// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/OrderArray.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ORDER_ARRAY__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ORDER_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/order_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'orders'
#include "tuw_multi_robot_msgs/msg/detail/order__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const OrderArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: orders
  {
    if (msg.orders.size() == 0) {
      out << "orders: []";
    } else {
      out << "orders: [";
      size_t pending_items = msg.orders.size();
      for (auto item : msg.orders) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OrderArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: orders
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.orders.size() == 0) {
      out << "orders: []\n";
    } else {
      out << "orders:\n";
      for (auto item : msg.orders) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OrderArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::msg::OrderArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::msg::OrderArray & msg)
{
  return tuw_multi_robot_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::OrderArray>()
{
  return "tuw_multi_robot_msgs::msg::OrderArray";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::OrderArray>()
{
  return "tuw_multi_robot_msgs/msg/OrderArray";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::OrderArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::OrderArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::OrderArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ORDER_ARRAY__TRAITS_HPP_
