// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_multi_robot_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_H_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'preconditions'
#include "tuw_multi_robot_msgs/msg/detail/route_precondition__struct.h"
// Member 'start'
// Member 'end'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in msg/RouteSegment in the package tuw_multi_robot_msgs.
/**
  * Describes a segment on a route with: start, end, width
  * and preconditions for synchronisation to other robots
 */
typedef struct tuw_multi_robot_msgs__msg__RouteSegment
{
  /// the unique identifier of a segment
  int32_t segment_id;
  /// the preconditions, which have to be met before entering a segment
  tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence preconditions;
  /// startpoint of the segment
  geometry_msgs__msg__Pose start;
  /// endpoint of the segment
  geometry_msgs__msg__Pose end;
  /// width of the segment
  float width;
} tuw_multi_robot_msgs__msg__RouteSegment;

// Struct for a sequence of tuw_multi_robot_msgs__msg__RouteSegment.
typedef struct tuw_multi_robot_msgs__msg__RouteSegment__Sequence
{
  tuw_multi_robot_msgs__msg__RouteSegment * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__msg__RouteSegment__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_H_
